
Uses Cfg
Uses User

const max_list = 20
const searchx = 20
const searchy = 23
const searchcol = '|11|16'
const morecol = '|11|16'

Const	HeaderOffset = 233

type 
  TTDFont = record
	A 				: char  // fixed : 13h
	typo			: Array[1..18] of char
	B				: char	// fixed : 1Ah
	fs				: array[1..4] of byte  // fixed: 55 AA 00 FF
	NameLen			: byte
	FontName		: array[1..12] of char
	nouse			: array[1..4] of byte  // 00 00 00 00
	FontType		: byte // Font Type (byte): 00 = Outline, 01 = Block, 02 = Color
	Spacing			: byte // 00 to 40d or 
	BlockSize		: word	// Block Size (Word, Little Endian) Size of character data after main
							// font definition block, including terminating 0 if followed by another
							// font (last font in collection is not Null terminated
	CharAddr		: Array[1..94] of word
							// 2 bytes (Word, Little Endian) for each character from ASC(33)
							//(“!”) to ASC(126) (“~”) (94 characters total) with the offset
							//(starting at 0) after the font header definition where the character
							// data star
	
	//At 233 begins the font data
end

Type
  TFontChar = Record
    width  : byte 				// 1 <= W <= 30 (1Eh)
    height : byte				// 1 <= H <= 12 (0Ch)
  end

Var FBTot,TotFiles  : Integer
Var Ok  : Boolean = True

Var TotalAreas:byte
Var Temp      :byte
Var Temp2     :byte  
Var Area      :array[1..max_list] of String
Var url       :array[1..max_list] of String
Var options   :array[1..max_list] of String
Var Idx       :Array[1..max_list] of byte
Var TopPage   :byte
Var BarPos    :byte
Var Done      : Boolean
Var Ch         :Char
Var Ch2        :Char
Var More      :byte
Var LastMore  :byte
Var IniFile		: String 
Var baronc : string
Var baroffc : string
Var command : string
Var optionsc : string
var search   :string
var search_idx:integer
var ii : integer
Var font 			: TTDFont
var Datapath 		: string
var FontFile		: String

Procedure XWindow(H1:String;T,X1,Y1,X2,Y2:Integer)
Var T1,A1,A2,B1,B2  : String
Begin
  A1:=Int2Str(X1)
  A2:=Int2Str(X2)
  B1:=Int2Str(Y1)
  B2:=Int2Str(Y2)
  T1:=Int2Str(T)
  Write('|#X#'+T1+'#'+H1+'#'+A1+'#'+B1+'#'+A2+'#'+B2+'#')
End

Procedure GetTDFHeader(f:string)
Var
  fptr : file
  i : integer
begin
  if not fileexist(f) then begin
	 writeln('Font file [ '+f+' ]does not exist');
	 pause
	 halt
  end
  fontfile:=f
  fassign(fptr,f,66)
  freset(fptr)
  fread(fptr,font,sizeof(font))
  fclose(fptr)
end

Procedure TDFWriteCharBL(x,y:byte;c:char):byte
Var
  fptr : file
  i : integer
  FChar : TFontChar
  tbyte : array[1..2] of byte
  sx,sy:byte
  asc:byte
begin
  if c=' ' then begin
	tdfwritecharBL:=1
	exit
  end
  asc:=ord(c)-32
  fassign(fptr,fontfile,66)
  freset(fptr)
  fseek(fptr,headeroffset+font.charaddr[asc])
  fread(fptr,FChar,sizeof(Fchar))
  tbyte[1]:=32
  tbyte[2]:=32
  gotoxy(x,y)
  while tbyte[1]<>0 and not feof(fptr) do begin
	fread(fptr,tbyte[1],1)
	if tbyte[1]=13 then begin
		gotoxy(x,wherey+1)
		if wherey>25 then break
	end
	 else begin
		fread(fptr,tbyte[2],1)
		textcolor(tbyte[2] % 16 + tbyte[2] - (tbyte[2] % 16))
		write(chr(tbyte[1]))
		if wherex>79 then break
	end
  end 
  fclose(fptr)
  tdfwritecharbl:=fchar.width
end

Procedure TDFWriteCharCL(x,y:byte;c:char):byte
Var
  fptr : file
  i : integer
  FChar : TFontChar
  tbyte : array[1..2] of byte
  sx,sy:byte
  asc:byte
begin
  if c=' ' then begin
	tdfwritecharcl:=1
	exit
  end
  asc:=ord(c)-32
  fassign(fptr,fontfile,66)
  freset(fptr)
  fseek(fptr,headeroffset+font.charaddr[asc])
  fread(fptr,FChar,sizeof(Fchar))
  tbyte[1]:=32
  gotoxy(x,y)
  while tbyte[1]<>0 and not feof(fptr) do begin
	fread(fptr,tbyte[1],1)
	if tbyte[1]=13 then begin
		gotoxy(x,wherey+1)
		if wherey>25 then break
	end
	 else begin
		write(chr(tbyte[1]))
		if wherex>79 then break
	end
  end 
  fclose(fptr)
  tdfwritecharcl:=fchar.width
end

procedure TDFWrite(x,y:byte; s:string)
Var
  i:byte
  sx,sy:byte
begin
  gotoxy(x,y)
  sx:=x
  sy:=y
  case font.fonttype of
  2: begin  
		  for i:=1 to length(s) do begin
			sx:=sx+tdfwritecharBL(sx,y,s[i])+font.spacing
		  end
	 end
  1: begin  
		  for i:=1 to length(s) do begin
			sx:=sx+tdfwritecharCL(sx,y,s[i])+font.spacing
		  end
	 end
   end
end

Procedure ReadIni
Var Fptr	: File
VAr Tag,Opt,S			: String
var i:integer
Begin
	If FileExist(IniFile) Then Begin
		fAssign(Fptr,IniFile,66)
		fReset(Fptr)
		While Not fEof(Fptr) Do Begin
			fReadLn(Fptr,S)
			Tag:=Upper(WordGet(1,S,'~'))
			Opt:=WordGet(2,S,'~')
			Case Tag Of
				'BARON' : baronc:=opt
				'BAROFF' : baroffc:=opt
				'COMMAND' : command:=opt
				'TOTAL_ITEMS' : totalareas := Str2Int(Opt)
			End
		End
		fClose(Fptr)
		fAssign(Fptr,IniFile,66)
		fReset(Fptr)
		i:=1
		While Not fEof(Fptr) Do Begin
			fReadLn(Fptr,S)
			Tag:=Upper(WordGet(1,S,'~'))
			Opt:=WordGet(2,S,'~')
			Case Tag Of
				'DESCRIPTION'+int2str(i) : area[i]:=opt
				'CMD'+int2str(i) : url[i]:=opt
				'OPTIONS'+int2str(i) : begin
											options[i]:=opt
											i:=i+1
										end
			End
		end	
		fClose(Fptr)
		//for i:=1 to max_list do areadisp[i]:=area[i]
	End
End

Procedure BarON
begin
  GotoXY (21, 9 + BarPos - TopPage)
  Write (baronc + PadRT(StripMCI(Area[BarPos]), 39, ' ') + '|16')
end

Procedure BarOFF
begin
  GotoXY (21, 9 + BarPos - TopPage)
  Write (baroffc + PadRT(Area[BarPos], 39, ' '))
  Write (StrREP(' ', 61 - WhereX))
end 

Procedure Center(s:string; line:byte)
begin
  gotoxy(40-(length(stripmci(s)) / 2),line)
  write(s)
end

Procedure DrawPage
begin
  Temp2 := BarPos
  For Temp := 0 to 11 do begin 
    BarPos := TopPage + Temp
    BarOFF
  end
  BarPos := Temp2
  BarON
  gotoxy(searchx,searchy)
  write(search)
end 

Procedure MainScreen
begin
  clrscr
  DataPath := JustPath(ProgName);	
  gettdfheader(datapath+'drgx.tdf') 		// Init the font to use
  font.spacing:=1
  xwindow(' Options ',1,19,7,61,22)
  tdfwrite(8,2,'Quick Menu Demo')	
  center(searchcol+'Press CTRL-Z for Help',24)
end

Procedure HelpScreen
begin
  clrscr
  bufflush
  DataPath := JustPath(ProgName);	
  gettdfheader(datapath+'drgx.tdf') 		// Init the font to use
  font.spacing:=1
  xwindow(' Keys ',1,20,7,60,20)
  tdfwrite(8,2,'Quick Menu Help')	
  gotoxy(22,8)
  write('|15CTRL-A    : |11Search Again')
  gotoxy(22,9)
  write('|15CTRL-Y    : |11Clear Search')
  gotoxy(22,10)
  write('|15Enter     : |11Select')
  gotoxy(22,11)
  write('|15End       : |11Bottom List')
  gotoxy(22,12)
  write('|15Home      : |11Top List')
  gotoxy(22,13)
  write('|15Up/Down   : |11Move Selection')
  gotoxy(22,14)
  write('|15Escape    : |11Abort / Go Back')  
  gotoxy(22,15)
  write('|15Any Key   : |11Search List')  
  center(searchcol+'Press Any Key to Continue...|PN',24)
  mainscreen
  drawpage
  bufflush
end

//Main Loop

begin

If Graphics = 0 Then begin
  writeln('|16|15No Graphics support. Exiting... |PA')
  Halt
End

if paramstr(1)='' then begin
  writeln('|12Configuration file not specified...|PA')
  halt
end;

inifile:=JustPath(ProgName)+paramstr(1)
readini

  
GetThisUser
clrscr

mainscreen

if command<>'' then menucmd('DT',command)
TopPage  := 1
BarPos   := 1
Done     := False
More     := 0
LastMore := 0
  search:='';
  search_idx:=0


DrawPage

Repeat
  More := 0
  Ch   := ' '
  Ch2  := ' '
  

  If TopPage > 1 Then begin
    More := 1
    Ch   := Chr(244)
  End

  If TopPage + 11 < TotalAreas Then begin
    Ch2  := Chr(245)
    More := More + 2
  End

  If More <> LastMore Then begin
    LastMore := More
    GotoXY (35, 21)
    Write (morecol+' (' + Ch + Ch2 + ' more) ')
  End

  Ch := ReadKey
  If IsArrow Then begin
	//HOME key
	if ch = chr(71) then begin
	search_idx:=1
		TopPage := 1
		BarPos  := 1
		drawpage
    end
	//END Key
	if ch = chr(79) then begin
	search_idx:=1
		if TotalAreas > 12 then begin
			TopPage := TotalAreas - 11
			BarPos  := TotalAreas
		end else begin
			BarPos  := TotalAreas
		end
		drawpage
    end
  
    If Ch = Chr(72) Then begin
    search_idx:=1
      If BarPos > TopPage Then begin
        BarOFF
        BarPos := BarPos - 1
        BarON
        end
      Else
      If TopPage > 1 Then begin
        TopPage := TopPage - 1
        BarPos  := BarPos  - 1
        DrawPage
      End
    end
  
    If Ch = Chr(73) Then begin
    search_idx:=1
      If TopPage - 12 > 0 Then begin
        TopPage := TopPage - 12
        BarPos  := BarPos  - 12
        DrawPage
        end
      Else begin
        TopPage := 1
        BarPos  := 1
        DrawPage
      End
    end
  
    If Ch = Chr(80) Then begin
    search_idx:=1
      If BarPos < TotalAreas Then
        If BarPos < TopPage + 11 Then begin
          BarOFF
          BarPos := BarPos + 1
          BarON
          end
        Else
        If BarPos < TotalAreas Then begin
          TopPage := TopPage + 1
          BarPos  := BarPos  + 1
          DrawPage
        End
      End        
  
    If Ch = Chr(81) Then begin
    search_idx:=1
      If TotalAreas > 12 Then
        If TopPage + 12 < TotalAreas - 12 Then begin
          TopPage := TopPage + 12
          BarPos  := BarPos  + 12
          DrawPage
          end
        Else
        begin
          TopPage := TotalAreas - 11
          BarPos  := TotalAreas
          DrawPage
        End
      Else
      begin
        BarOFF
        BarPos := TotalAreas
        BarON
      End
    End    
  ch:=#0
  end else
  If Ch = Chr(26) Then begin
    helpscreen
    //If Not IsNoFile Then begin
      Ch := ReadKey
      mainscreen
      DrawPage
    //End
    end
  Else
  if ch=chr(8) then begin
	delete(search,length(search),1)
	gotoxy(searchx,searchy)
	write(searchcol+upper(search)+' ')	
	for ii:=1 to max_list do begin
		if pos(search,upper(area[ii]))>0 then begin
			TopPage := ii
            BarPos  := ii
            search_idx:=ii
            DrawPage
		end
	end	
  end 
  if Ch = Chr(13) then begin
	MenuCmd('GT','|CL')
	menucmd(url[barpos],options[barpos])
	//MenuCmd('GT','|PA')
	mainscreen
	DrawPage
  end else 
  if ch = chr(1) then begin
    for ii:=search_idx+1 to max_list do begin
		if pos(search,upper(area[ii]))>0 then begin
			TopPage := ii
            BarPos  := ii
            search_idx:=ii
            DrawPage
            break
		end
	end	
  end else
  if ch = chr(25) then begin
    gotoxy(searchx,searchy)
	write(strrep(' ',length(search)))
	search:='';
	search_idx:=0
  end else
  If Ch = Chr(27) Then begin
    Done := True
  End else if ch>=chr(32) and ch<=chr(128) then begin
	search:=search+upper(ch)
	gotoxy(searchx,searchy)
	write(searchcol+upper(search))	
	for ii:=1 to max_list do begin
		if pos(search,upper(area[ii]))>0 then begin
			TopPage := ii
            BarPos  := ii
            search_idx:=ii
            DrawPage
            break
		end
	end	
  
  end
Until Done

GotoXY (1, 23)

end
